



#runs as player that clickewd
#team stuff
tag @a remove lose_team_1
tag @a remove lose_team_2
tag @a remove lose_team_both
tag @a remove tm1
tag @a remove tm2
tag @a remove has_tm2_flag
tag @a remove has_tm1_flag
tag @a add can_steal



#tag players
execute if score !playercount game matches 1 run tag @a[scores={tank_selected=1..},sort=random,limit=2] add join
execute if score !playercount game matches 2 run tag @a[scores={tank_selected=1..},sort=random,limit=4] add join
execute if score !playercount game matches 3 run tag @a[scores={tank_selected=1..},sort=random,limit=6] add join
execute if score !playercount game matches 4 run tag @a[scores={tank_selected=1..},sort=random,limit=8] add join
execute if score !playercount game matches 5 run tag @a[scores={tank_selected=1..},sort=random,limit=10] add join
execute if score !playercount game matches 6 run tag @a[scores={tank_selected=1..},sort=random,limit=12] add join
execute if score !playercount game matches 7 run tag @a[scores={tank_selected=1..},sort=random,limit=14] add join
execute if score !playercount game matches 8 run tag @a[scores={tank_selected=1..},sort=random,limit=16] add join
execute if score !playercount game matches 9 run tag @a[scores={tank_selected=1..},sort=random,limit=18] add join
execute if score !playercount game matches 10 run tag @a[scores={tank_selected=1..},sort=random,limit=20] add join

#sounds
stopsound @a[tag=join] * minecraft:map.main_music_loop

#messages if not joined
execute as @a[tag=!join] run playsound minecraft:map.error_normal ambient @s ~ ~ ~ 10 1
execute as @a[tag=!join] unless score @s tank_selected matches 1.. run tellraw @s ["",{"text":"[Failed to join game]","underlined":true,"color":"dark_red"},{"text":" You dont\nhave a tank selected, select/buy\na tank and wait for next time!","color":"red"}]
execute as @a[tag=!join] if score @s tank_selected matches 1.. run tellraw @s ["",{"text":"[Failed to join game]","underlined":true,"color":"dark_red"},{"text":" The game was\nsadly full! Better luck next time!","color":"red"}]

#gamemode
execute if score !gamemode game matches 5 run function bot_tank:random_gamemode

#choose map
execute if score !map game matches 1 run function bot_tank:random_map
execute unless score !map game matches 1 run scoreboard players operation !map_this game = !map game

#create teams and bots
function we:set_team



#forceload all chunks
forceload add -8 -3 59 64
forceload add 9991 18 10092 -28
forceload add 19989 31 20076 -37
forceload add 30071 -6 29937 37
forceload add 40064 -10 39988 112
forceload add 50065 -29 49961 13
forceload add 59921 61 60033 -28
forceload add 70025 -15 69909 47
forceload add 80087 -79 79919 84
forceload add 89899 76 90009 -15
forceload add 99917 79 100087 -78

#game settings
difficulty easy
gamerule doFireTick false
gamemode adventure @a



#give id
scoreboard players set !next_id game 1
scoreboard players set @e[tag=join] pl_id 0
execute as @e[tag=join] at @s run function we:game_give_pl_id

#give all players and bots player tag
tag @e[tag=join] add player
tag @a[tag=join] add ingame
clear @a[tag=join]

#set score
scoreboard players set !gameactive game 1

#load a map
#execute if score !map_this game matches 1 run function bot_tank:random_map
execute if score !map_this game matches 2 run function we:game_map_1
execute if score !map_this game matches 3 run function we:game_map_2
execute if score !map_this game matches 4 run function we:game_map_3
execute if score !map_this game matches 5 run function we:game_map_4
execute if score !map_this game matches 6 run function we:game_map_5
execute if score !map_this game matches 7 run function we:game_map_6
execute if score !map_this game matches 8 run function we:game_map_7
execute if score !map_this game matches 9 run function we:game_map_8
execute if score !map_this game matches 10 run function we:game_map_9
execute if score !map_this game matches 11 run function we:game_map_10


#teleport bots and players to map
execute as @e[tag=join] at @s run function we:game_tp_start

#set bot type and tank selected
execute if score @s tier_unlocked matches 1 as @e[tag=join,tag=bot] run function bot_tank:level_9
execute if score @s tier_unlocked matches 2 as @e[tag=join,tag=bot] run function bot_tank:level_1
execute if score @s tier_unlocked matches 3 as @e[tag=join,tag=bot] run function bot_tank:level_2
execute if score @s tier_unlocked matches 4 as @e[tag=join,tag=bot] run function bot_tank:level_3
execute if score @s tier_unlocked matches 5 as @e[tag=join,tag=bot] run function bot_tank:level_4
execute if score @s tier_unlocked matches 6 as @e[tag=join,tag=bot] run function bot_tank:level_5
execute if score @s tier_unlocked matches 7 as @e[tag=join,tag=bot] run function bot_tank:level_6
execute if score @s tier_unlocked matches 8 as @e[tag=join,tag=bot] run function bot_tank:level_7
execute if score @s tier_unlocked matches 9 as @e[tag=join,tag=bot] run function bot_tank:level_8
#execute if score @s tier_unlocked matches 8.. as @e[tag=join,tag=bot] run function bot_tank:level_9

#set scores
scoreboard players set !base_health_t1 game 1000
scoreboard players set !base_health_t2 game 1000
bossbar set base_t1 players @a[tag=join]
bossbar set base_t2 players @a[tag=join]
bossbar set main_game players @a[tag=join]
bossbar set king_base players @a[tag=join]
execute if score !gamemode game matches 4 run bossbar set king_base visible true
execute if score !gamemode game matches 4 run bossbar set king_base value 0
execute if score !gamemode game matches 4 run bossbar set king_base color white
bossbar set main_game visible true
scoreboard players set !game_lose_time game 0
scoreboard players set @a[tag=join] gold_earned 0
scoreboard players set @a[tag=join] death_timer 0
scoreboard players set @e[tag=join] respawn_timer 0
scoreboard players set !alive_tanks_t1 game 0
scoreboard players set !alive_tanks_t2 game 0

#create tank
execute as @e[tag=join] at @s run function we:create_tank

#just for look
tag @a remove get_got_tank
effect give @a[tag=join] blindness 2 1 true
effect give @a[tag=join] jump_boost 11 252 true
effect give @a[tag=join] slowness 11 255 true

#set player and bot tank health
execute as @e[tag=join] run function game:set_tank_health

#set reload and repair time and title time and drop_item
scoreboard players set @e[tag=join] reload_time 0
scoreboard players set @e[tag=join] repair_time 0
scoreboard players set @e[tag=join] title_timer 0
scoreboard players set @e[tag=join] drop_item 0

#set match time
execute if score !time game matches 1 run scoreboard players set !game_time_min game 2
execute if score !time game matches 1 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 2 run scoreboard players set !game_time_min game 3
execute if score !time game matches 2 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 3 run scoreboard players set !game_time_min game 5
execute if score !time game matches 3 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 4 run scoreboard players set !game_time_min game 7
execute if score !time game matches 4 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 5 run scoreboard players set !game_time_min game 10
execute if score !time game matches 5 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 6 run scoreboard players set !game_time_min game 13
execute if score !time game matches 6 run scoreboard players set !game_time_sec game 0

execute if score !time game matches 7 run scoreboard players set !game_time_min game 16
execute if score !time game matches 7 run scoreboard players set !game_time_sec game 0

execute if score !gamemode game matches 1 if score !game_time_min game matches ..9 run scoreboard players set !game_time_min game 10
execute if score !gamemode game matches 1 if score !game_time_min game matches ..9 run scoreboard players set !game_time_sec game 0


#set xp points to 0
experience set @a[tag=join] 0 points

#message about settings and team, we do tellraw in create team function
execute as @a[tag=join] at @s run playsound minecraft:map.battle_start ambient @s ~ ~ ~ 100 0.7
execute as @a[tag=join] at @s run playsound minecraft:map.battle_count ambient @s ~ ~ ~ 100 1

#start timer
scoreboard players set !countdown_timer game 10
schedule function we:game_start_timer 5t

#set ai scores and player scores
execute as @e[tag=join,tag=bot] run scoreboard players set @s time_since_shot 300
scoreboard players set @e[tag=join] ai_stuck_timer 0
scoreboard players set @e[tag=join,tag=bot] death_timer 0

#special bots
execute if score !gamemode game matches 3..4 run tag @e[tag=bot,tag=tm1,sort=random,limit=1] add can_steal
execute if score !gamemode game matches 3..4 run tag @e[tag=bot,tag=tm2,sort=random,limit=1] add can_steal

#set hitbox glow
execute if score !playerglow game matches 1 as @e[tag=en_hitbox] run data merge entity @s {Glowing:1b}

#remove tags
tag @a remove 10sec_left_once
tag @a remove cannon_broke
tag @a remove turret_broke
tag @a remove engine_fire
tag @a remove just_shot
tag @e remove join
kill @e[tag=player_start_pos]

